//[leakcanary-android-release](../../index.md)/[leakcanary](index.md)

# Package leakcanary

## Types

| Name | Summary |
|---|---|
| [BackgroundTrigger](-background-trigger/index.md) | [androidJvm]<br>class [BackgroundTrigger](-background-trigger/index.md)(application: [Application](https://developer.android.com/reference/kotlin/android/app/Application.html), analysisClient: [HeapAnalysisClient](-heap-analysis-client/index.md), analysisExecutor: [Executor](https://developer.android.com/reference/kotlin/java/util/concurrent/Executor.html), processInfo: [ProcessInfo](-process-info/index.md), analysisCallback: ([HeapAnalysisJob.Result](-heap-analysis-job/-result/index.md)) -&gt; [Unit](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)) |
| [ConditionalInterceptor](-conditional-interceptor/index.md) | [androidJvm]<br>class [ConditionalInterceptor](-conditional-interceptor/index.md)(delegate: [HeapAnalysisInterceptor](-heap-analysis-interceptor/index.md), evaluateCondition: ([HeapAnalysisJob](-heap-analysis-job/index.md)) -&gt; [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)) : [HeapAnalysisInterceptor](-heap-analysis-interceptor/index.md)<br>An interceptor that runs only when evaluateCondition returns true. |
| [GoodAndroidVersionInterceptor](-good-android-version-interceptor/index.md) | [androidJvm]<br>class [GoodAndroidVersionInterceptor](-good-android-version-interceptor/index.md) : [HeapAnalysisInterceptor](-heap-analysis-interceptor/index.md) |
| [HeapAnalysisClient](-heap-analysis-client/index.md) | [androidJvm]<br>class [HeapAnalysisClient](-heap-analysis-client/index.md)(heapDumpDirectoryProvider: () -&gt; [File](https://developer.android.com/reference/kotlin/java/io/File.html), config: [HeapAnalysisConfig](-heap-analysis-config/index.md), interceptors: [List](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)&lt;[HeapAnalysisInterceptor](-heap-analysis-interceptor/index.md)&gt;) |
| [HeapAnalysisConfig](-heap-analysis-config/index.md) | [androidJvm]<br>data class [HeapAnalysisConfig](-heap-analysis-config/index.md)(referenceMatchers: [List](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)&lt;ReferenceMatcher&gt;, objectInspectors: [List](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)&lt;ObjectInspector&gt;, metadataExtractor: MetadataExtractor, computeRetainedHeapSize: [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html), leakingObjectFinder: LeakingObjectFinder, stripHeapDump: [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)) |
| [HeapAnalysisInterceptor](-heap-analysis-interceptor/index.md) | [androidJvm]<br>fun interface [HeapAnalysisInterceptor](-heap-analysis-interceptor/index.md) |
| [HeapAnalysisJob](-heap-analysis-job/index.md) | [androidJvm]<br>interface [HeapAnalysisJob](-heap-analysis-job/index.md)<br>A [HeapAnalysisJob](-heap-analysis-job/index.md) represents a single prepared request to analyze the heap. It cannot be executed twice. |
| [JobContext](-job-context/index.md) | [androidJvm]<br>class [JobContext](-job-context/index.md)(starter: [Class](https://developer.android.com/reference/kotlin/java/lang/Class.html)&lt;*&gt;?)<br>In memory store that can be used to store objects in a given [HeapAnalysisJob](-heap-analysis-job/index.md) instance. This is a simple [MutableMap](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-mutable-map/index.html) of [String](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html) to [Any](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html), but with unsafe generics access. |
| [MinimumDiskSpaceInterceptor](-minimum-disk-space-interceptor/index.md) | [androidJvm]<br>class [MinimumDiskSpaceInterceptor](-minimum-disk-space-interceptor/index.md)(application: [Application](https://developer.android.com/reference/kotlin/android/app/Application.html), minimumDiskSpaceBytes: [Long](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html), processInfo: [ProcessInfo](-process-info/index.md)) : [HeapAnalysisInterceptor](-heap-analysis-interceptor/index.md) |
| [MinimumElapsedSinceStartInterceptor](-minimum-elapsed-since-start-interceptor/index.md) | [androidJvm]<br>class [MinimumElapsedSinceStartInterceptor](-minimum-elapsed-since-start-interceptor/index.md)(minimumElapsedSinceStartMillis: [Long](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html), processInfo: [ProcessInfo](-process-info/index.md)) : [HeapAnalysisInterceptor](-heap-analysis-interceptor/index.md) |
| [MinimumMemoryInterceptor](-minimum-memory-interceptor/index.md) | [androidJvm]<br>class [MinimumMemoryInterceptor](-minimum-memory-interceptor/index.md)(application: [Application](https://developer.android.com/reference/kotlin/android/app/Application.html), minimumRequiredAvailableMemoryBytes: [Long](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html), processInfo: [ProcessInfo](-process-info/index.md)) : [HeapAnalysisInterceptor](-heap-analysis-interceptor/index.md) |
| [OncePerPeriodInterceptor](-once-per-period-interceptor/index.md) | [androidJvm]<br>class [OncePerPeriodInterceptor](-once-per-period-interceptor/index.md)(application: [Application](https://developer.android.com/reference/kotlin/android/app/Application.html), periodMillis: [Long](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)) : [HeapAnalysisInterceptor](-heap-analysis-interceptor/index.md)<br>Proceeds once per period (of time) and then cancels all follow up jobs until period has passed. |
| [ProcessInfo](-process-info/index.md) | [androidJvm]<br>interface [ProcessInfo](-process-info/index.md) |
| [SaveResourceIdsInterceptor](-save-resource-ids-interceptor/index.md) | [androidJvm]<br>class [SaveResourceIdsInterceptor](-save-resource-ids-interceptor/index.md)(resources: [Resources](https://developer.android.com/reference/kotlin/android/content/res/Resources.html)) : [HeapAnalysisInterceptor](-heap-analysis-interceptor/index.md)<br>Interceptor that saves the names of R.id.* entries and their associated int values to a static field that can then be read from the heap dump. |
| [ScreenOffTrigger](-screen-off-trigger/index.md) | [androidJvm]<br>class [ScreenOffTrigger](-screen-off-trigger/index.md)(application: [Application](https://developer.android.com/reference/kotlin/android/app/Application.html), analysisClient: [HeapAnalysisClient](-heap-analysis-client/index.md), analysisExecutor: [Executor](https://developer.android.com/reference/kotlin/java/util/concurrent/Executor.html), analysisCallback: ([HeapAnalysisJob.Result](-heap-analysis-job/-result/index.md)) -&gt; [Unit](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)) |
